function findbrightest, linex, linestrength, nfind, xrange=xrange, minrelstrength=minrelstrength, indices=indices

   ; find the "brightest" nfind lines (as ranked by isolation from next-brightest line)

   if nfind ge n_elements(linex) then return, linex
   if n_elements(minrelstrength) eq 0 then minrelstrength = 0

   if n_elements(xrange) gt 0 then xmin = xrange[0] else xmin = min(linex)-0.1
   if n_elements(xrange) gt 1 then xmax = xrange[1] else xmax = max(linex)+0.1
   minstrength = minrelstrength*max(linestrength)

   w = where(linex ge xmin and linex le xmax and linestrength ge minstrength)
   x = linex[w]   
   y = linestrength[w]
   r = rank(linestrength)
 
   n = n_elements(x)
   prom = fltarr(n)
   ;method = 'scalesum'
   method = 'sum'
   if method eq 'abs' then begin
      for i = 0, n-1 do begin
         dist = abs(x-x[i])
         brighter = where(y gt y[i]*0.05 and x ne x[i], ct)
         if ct eq 0 then begin
            prom[i] += !values.f_infinity
         endif else begin
            prom[i] += min(dist[brighter])
         endelse
      endfor
   endif 
   if method eq 'sum' then begin  ; sum of left and right 
      for i = 0, n-1 do begin
         dist = abs(x-x[i])
         brighterleft = where(y gt y[i]*0.99 and x lt x[i], ctleft)
         brighterright = where(y gt y[i]*0.99 and x gt x[i], ctright)
         if ctleft  gt 0 then lprom = min(dist[brighterleft])  else lprom = x[i]-min(x)
         if ctright gt 0 then rprom = min(dist[brighterright]) else rprom = max(x)-x[i]
         prom[i] += lprom + rprom
         ;if n lt 200 then print, x[i], y[i], ' | ', ctleft, ctright, ' | ',  lprom, rprom, '|', prom[i]
      endfor
   endif
   if method eq 'scalesum' then begin
      for i = 0, n-1 do begin
         dist = abs(x-x[i])
         brighterleft = where(y gt y[i]*0.3 and x lt x[i], ctleft)
         brighterright = where(y gt y[i]*0.3 and x gt x[i], ctright)
         if ctleft  gt 0 then lprom = min(dist[brighterleft])  else lprom = x[i]-min(x)
         if ctright gt 0 then rprom = min(dist[brighterright]) else rprom = max(x)-x[i]
         prom[i] += (lprom + rprom)/(10+r[i]) ; the rank division is the only difference
         ;wneighborleft  = where(dist eq min(dist[brighterleft]))
         ;wneighborright = where(dist eq min(dist[brighterright]))
         ;if ctleft  gt 0 then lprom = dist[wneighborleft]/(10+r[i])    else lprom = (x[i]-min(x))/(10+r[i])
         ;if ctright gt 0 then rprom = dist[wneighborright])/(10+r[i])  else rprom = (max(x)-x[i])/(10+r[i])
         prom[i] += lprom + rprom
      endfor
   endif

   sprom = reverse(sort(prom))

   xout = x[sprom[0:nfind-1]]
   yout = y[sprom[0:nfind-1]]

   s = sort(xout)
   xout = xout[s]
   yout = yout[s]

   indices = intarr(n_elements(xout))
   for i = 0, n_elements(xout)-1 do indices[i] = (where(linex eq xout[i])) [0]

;psclose
;window, 0
;!p.multi = 0
;!p.position = 0
;plot, x, y, psym=1, yrange=[1.0,2.1]*1.02e6, /ystyle
;oplot, xout, yout, psym=7
;stop

   return, xout

end

