function get2mass, ra, dec, radius

  ; the scat and vizier style queries are in the old version of this code


  if size(ra,/tn) eq 'STRING' then rainp = ten(ra)*15. else rainp = ra
  if size(dec,/tn) eq 'STRING' then decinp = ten(dec) else decinp = dec

   ; could replace tsv with txt
   queryurl = 'http://webviz.u-strasbg.fr/viz-bin/asu-tsv?-source=2MASS-PSC&-c.ra='+clip(rainp)+'&-c.dec='+clip(decinp)+'&-c.rm='+clip(radius/60.)+'&-out.max=unlimited
   command = 'wget "' + queryurl + '" -O tempcatin.dat -q'
   ;print, command
   spawn, command

   ;remove all the comments and other annoyances
   openr, 10, 'tempcatin.dat'
   inline = ''
   openw, 11, 'tempcat.dat'
   while not eof(10) do begin
      readf, 10, inline
      if strlen(inline) lt 10 then continue
      if strmid(inline,0,1) eq '#' then continue
      if strmid(inline,0,3) eq '   ' then continue
      if strmid(inline,0,1) eq '-' then continue
      if strmid(inline,0,1) eq 'R' then inline = '#'+inline
      if strmid(inline,0,1) eq 'd' then continue
      if strmid(inline,0,6) eq '2000 (' then continue
      inline = repstr(inline,string(9b)+'      '+string(9b), string(9b)+'-1   '+string(9b))
      inline = repstr(inline,'RAJ2000','RA        ')
      inline = repstr(inline,'DEJ2000','dec       ')
      inline = repstr(inline,'2MASS','2MASS_ID         ')
      ;print, inline
      printf, 11, inline
   endwhile
   close, 10
   close, 11

   nl = countlines('tempcat.dat')-1
   if nl le 0 then return, -1

   readcol, 'tempcat.dat', ra, dec, id, J, J_unc, H, H_unc, K, K_unc, q, r, b, c, x, a, format='f,f,a,f,f,f,f,f,f,a,a,a,a,a,a', comment='#', count=n, /silent
   if n eq 0 then return, -1
   

   tmc = replicate({id:'', ra:0.D, dec:0.D, $
                     Y:0.,    J:0.,    H:0.,    Ks:0.,     Kp:0.,     K:0., $
                     Y_unc:0.,J_unc:0.,H_unc:0.,Ks_unc:0., Kp_unc:0., K_unc:0., $
                     type:0   },n)

   tmc.ra  = ra
   tmc.dec = dec
   tmc.id = '2MASS'+id
   tmc.J = J
   tmc.H = H
   tmc.Ks = K
   tmc.J_unc = J_unc
   tmc.H_unc = H_unc
   tmc.Ks_unc = K_unc

   tmc.K =  tmc.Ks - 0.026*(tmc.J-tmc.Ks)        - 0.002 ; basically no difference
   tmc.Kp = tmc.K  + 0.18*((tmc.H-tmc.K) < 0.18) + 0 ; effect saturates, see Wainscoat & Cowie
   tmc.Y =  tmc.J  + 1.104*(tmc.J-tmc.H)         - 0.04  ;  (sigma 0.08)

   tmc.K_unc =  sqrt( (0.974*tmc.Ks_unc)^2 + (0.026*tmc.J_unc)^2)
   tmc.Kp_unc = sqrt( (1.18*tmc.K_unc)^2   + (0.18*tmc.H_unc)^2 )
   tmc.Y_unc =  sqrt( (2.104*tmc.J_unc)^2 + (1.104*tmc.H_unc)^2)

   kndet = where(tmc.Ks_unc eq -1, ct)
   if ct gt 0 then begin
       tmc[kndet].Ks = 0.
       tmc[kndet].Kp = 0.
       tmc[kndet].K = 0.
       tmc[kndet].Ks_unc = 0.
       tmc[kndet].Kp_unc = 0.
       tmc[kndet].K_unc = 0.
   endif
   hndet = where(tmc.H_unc eq -1, ct)
   if ct gt 0 then begin
       tmc[hndet].H = 0.
       tmc[hndet].Y = 0.
       tmc[hndet].Kp = tmc[hndet].K
   endif  
   jndet = where(tmc.J_unc eq -1, ct)
   if ct gt 0 then begin
       tmc[jndet].J = 0.
       tmc[hndet].K = tmc[hndet].Ks
   endif


   return, tmc

end

