function getpixelscale, inp

 ; Get the mean pixel scale (arcsec/pix) from an image or image header.

  if n_elements(inp) eq 0 then return, !values.f_nan
  if n_elements(inp) eq 1 then begin
    check = file_test(inp)
    if check eq 0 then begin
       print, 'File ', inp, ' not found.'
       return, !values.f_nan
    endif
    h = headfits(inp)
  endif
  if n_elements(inp) gt 1 then begin
    h = inp
  endif

  pixscale = !values.f_nan
  cd11 = sxpar(h,'CD1_1', count=ct)
  cd12 = sxpar(h,'CD1_2')
  cd21 = sxpar(h,'CD2_1')
  cd22 = sxpar(h,'CD2_2')
  if ct gt 0 then begin
    xscale = 3600. * sqrt(cd11^2 + cd21^2)
    yscale = 3600. * sqrt(cd12^2 + cd22^2)
    pixscale = sqrt(xscale*yscale)
  endif else begin
    xscale = 3600. * abs(sxpar(h,'CDELT1'))
    yscale = 3600. * abs(sxpar(h,'CDELT2'))
    pixscale = sqrt(xscale*yscale)
  endelse 

  return, pixscale

end

