function getsdss, ra, dec, radius, url=url, count=count, pauseduration=pauseduration ;, catalog=catalog

   ; SDSS cone search.  Returns a structure of magnitudes, including magnitudes transformed to Johnson-Cousins filters.

   ; radius/boxsize is in arcsec

   catalog = 'sdss'
   if n_elements(pauseduration) eq 0 then pauseduration = 60.

   rainp = clip(string(ra))
   decinp = clip(string(dec))
   radinp = clip(radius/60.) ; sdss direct query only

   if strpos(rainp,':') gt 0 then rainp = clip(15*ten(ra))
   if strpos(decinp,':') gt 0 then decinp = clip(ten(dec))

    queryurl = '"http://skyserver.sdss.org/dr12/en/tools/search/x_results.aspx?searchtool=Radial&TaskName=Skyserver.Search.Radial&whichphotometry=optical&coordtype=equatorial&ra='+rainp+'&dec='+decinp+'&radius='+radinp+'&min_u=0&max_u=30&min_g=0&max_g=30&min_r=0&max_r=30&min_i=0&max_i=30&min_z=0&max_z=30&min_j=0&max_j=30&min_h=0&max_h=30&min_k=0&max_k=30&format=csv&limit=5000"' ; DR12

;    queryurl = '"http://skyserver.sdss.org/dr12/en/tools/search/x_radial.aspx?whichway=equitorial&ra='+rainp+'&dec='+decinp+'&radius='+radinp+'&min_u=0&max_u=30&min_g=0&max_g=30&min_r=0&max_r=30&min_i=0&max_i=30&min_z=0&max_z=30&format=csv&limit=5000"' ; DR12
;   queryurl = '"http://skyserver.sdss3.org/public/en/tools/search/x_radial.aspx?whichway=equitorial&ra='+rainp+'&dec='+decinp+'&radius='+radinp+'&min_u=0&max_u=30&min_g=0&max_g=30&min_r=0&max_r=30&min_i=0&max_i=30&min_z=0&max_z=30&format=csv&limit=5000"' ; DR10, though seems to redirect
;   queryurl = '"http://cas.sdss.org/astro/en/tools/search/x_radial.asp?ra='+rainp+'&dec='+decinp+'&radius='+radinp+'&min_u=0&max_u=30&min_g=0&max_g=30&min_r=0&max_r=30&min_i=0&max_i=30&min_z=0&max_z=30&entries=top&topnum=5000&format=csv"' DR7

   ;;queryurl = "http://tdc-www.harvard.edu/cgi-bin/scat\?catalog=" + catalog +  "\&ra=" + rainp + "\&dec=" + decinp + "\&system=J2000\&rad=" + clip(-boxsize) + "\&sort=mag\&epoch=2000.00000\&nstar=1600"

   ; &min_u=0&max_u=30&min_g=0&max_g=30&min_r=0&max_r=30&min_i=0&max_i=30&min_z=0&max_z=30

   url = queryurl

   command = 'wget ' + queryurl + ' -O tempcat.dat -q'
   spawn, command

   ns = 0
   openr, 15, 'tempcat.dat'
   inline = ''
   while not eof(15) do begin
     readf, 15, inline
     c1 = strmid(inline,0,1)
     if c1 ne '#' and c1 ne 'a' and c1 ne '' and c1 ne 'o' then ns += 1
   endwhile
   close, 15
   if ns le 0 then return, -1

   ;readcol, 'tempcat.dat', id, sra, sdec, u, g, r, i, z, type, dist, format='l,a,a,f,f,f,f,f,i,f', skipline=12, /silent
   readcol, 'tempcat.dat', ids, run, rerun, camcol, field, obj, type, ra, dec, u, g, r, i, z, u_unc, g_unc, r_unc, i_unc, z_unc, format='a,i,i,i,i,i,i,d,d,f,f,f,f,f,f,f,f,f,f' , skipline=1, comment='#', stringskip='a', /silent   ; formerly skipline 12
   count = 0
   if n_elements(ids) gt 0 then begin
      id = long64(ids) ; format 'll' should work  but doesn't seem to
      w = where(id gt 0, count)
      if count gt 0 then id = id[w]
   endif
   if n_elements(ids) eq 0 or count eq 0 then begin  ; redundant condition here
     openr, 15, 'tempcat.dat'
     inline = ''
     while not eof(15) do begin
        readf, 15, inline ; note that it's not iterating; it's searching for the error string.
        if strpos(inline, 'Maximum') ge 0 then begin
           print, 'SDSS query rejected.  Pausing for ', clip(round(pauseduration)), ' seconds, then re-trying.'
           close, 15
           wait, pauseduration
           spawn, command
           readcol, 'tempcat.dat', ids, run, rerun, camcol, field, obj, type, ra, dec, u, g, r, i, z, u_unc, g_unc, r_unc, i_unc, z_unc, format='a,i,i,i,i,i,i,d,d,f,f,f,f,f,f,f,f,f,f' , skipline=1, comment='#', stringskip='a', /silent   ; formerly skipline 12
           if n_elements(ids) gt 0 then begin
              id = long64(ids) ; format 'll' should work  but doesn't seem to
              w = where(id gt 0, count)
              if count gt 0 then id = id[w]
              if count gt 0 then print, 'Success!'
           endif
           if n_elements(ids) eq 0 or count eq 0 then begin
              openr, 15, 'tempcat.dat'
              inline = ''
              while not eof(15) do begin
                 readf, 15, inline ; note that it's not iterating; it's searching for the error string.
                 if strpos(inline, 'Maximum') ge 0 then begin
                    print, 'SDSS query rejected again.  Giving up.'
                    break
                 endif
              endwhile
            endif
            break
        endif
     endwhile
     close, 15 ; OK to close twice  
   endif
   if count eq 0 then return, -1

   ;count = n_elements(id)

   ;if n le 1 then return, -1

   sdss = replicate({id:0LL, sra:'',sdec:'',ra:0.D, dec:0.D, $
                     u:0.,g:0.,r:0.,i:0.,z:0.,                     Uj:0., Bj:0.,Vj:0.,Rc:0.,Ic:0., $
                     u_unc:0.,g_unc:0.,r_unc:0.,i_unc:0.,z_unc:0., Uj_unc:0.,Bj_unc:0.,Vj_unc:0.,Rc_unc:0.,Ic_unc:0., $
                     type:0},count)
   sdss.id = id
   ;sdss.sra = sra
   ;sdss.sdec = sdec
   sdss.u = u
   sdss.g = g
   sdss.r = r
   sdss.i = i
   sdss.z = z
   sdss.u_unc = u_unc
   sdss.g_unc = g_unc
   sdss.r_unc = r_unc
   sdss.i_unc = i_unc
   sdss.z_unc = z_unc
   sdss.type = type
   ;for i = 0, n-1 do begin
   ;  sdss[i].ra = 15*ten(sra[i])
   ;  sdss[i].dec = ten(sdec[i])
   ;endfor
   sdss.ra = ra
   sdss.dec = dec

   sdss.Uj =  u - 0.0216*(u - g) - 0.799 ; combination of 2 equations, fortunately not needed

   sdss.Bj = (u - 0.8116*(u - g) + 0.1313)*0+$;  sigma = 0.0095
             (g + 0.3130*(g - r) + 0.2271)*1;    sigma = 0.0107

   sdss.Vj = (g - 0.2906*(u - g) + 0.0885)*0+$;  sigma = 0.0129
             (g - 0.5784*(g - r) - 0.0038)*1;    sigma = 0.0054

   sdss.Rc = (r - 0.1837*(g - r) - 0.0971)/2+$;  sigma = 0.0106
             (r - 0.2936*(r - i) - 0.1439)/2;    sigma = 0.0072

   sdss.Ic = (r - 1.2444*(r - i) - 0.3820)*1+$;  sigma = 0.0078
             (i - 0.3780*(i - z) - 0.3974)*0;    sigma = 0.0063

   sdss.Uj_unc =  u_unc

   sdss.Bj_unc = sqrt((g_unc * 1.3130)^2 + (r_unc*0.2271)^2 + 0.0107^2)

   sdss.Vj_unc = sqrt((g_unc*(1-0.5784))^2 + (r_unc*0.5784)^2 + 0.0054^2)

   sdss.Rc_unc = sqrt(r_unc^2 + 0.0106^2)

   sdss.Ic_unc = sqrt((r_unc*0.2444)^2 + (i_unc*1.2444)^2 + 0.0078^2)


   return, sdss

end
