function getusno, ra, dec, radius ;, catalog=catalog

   ; boxsize in arcsec, apparently

   catalog = 'ub2'

   rainp = clip(string(ra))
   decinp = clip(string(dec))
   radinp = clip(radius/60.) ; usno direct query only
   boxsize = radius

   if strpos(rainp,':') gt 0 then rainp = clip(15*ten(ra))
   if strpos(decinp,':') gt 0 then decinp = clip(ten(dec))

   queryurl = "http://tdc-www.harvard.edu/cgi-bin/scat\?catalog=" + catalog +  "\&ra=" + rainp + "\&dec=" + decinp + "\&system=J2000\&rad=" + clip(-boxsize) + "\&sort=mag\&epoch=2000.00000\&nstar=6400" ; formerly 1600

   ;queryurl = '"http://cas.usno.org/astro/en/tools/search/x_radial.asp?ra='+rainp+'&dec='+decinp+'&radius='+radinp+'&min_u=0&max_u=30&min_g=0&max_g=30&min_r=0&max_r=30&min_i=0&max_i=30&min_z=0&max_z=30&entries=top&topnum=1000&format=csv"'

   ; &min_u=0&max_u=30&min_g=0&max_g=30&min_r=0&max_r=30&min_i=0&max_i=30&min_z=0&max_z=30

   command = 'wget ' + queryurl + ' -O tempcat.dat -q'
   spawn, command

   n = countlines('tempcat.dat')-12 ; -1
   if n le 0 then return, -1

   readcol, 'tempcat.dat', id, sra, sdec, B1, R1, B2, R2, I, pm, ni, sg, dist, format='l,a,a,f,f,f,f,f,i,i,i,f', skipline=12, /silent
   ;readcol, 'tempcat.dat', id, run, rerun, camcol, field, obj, type, ra, dec, u, g, r, i, z, u_unc, g_unc, r_unc, i_unc, z_unc, format='ll,i,i,i,i,i,i,d,d,f,f,f,f,f,f,f,f,f,f' , skipline=1, /silent   ; formerly skipline 12

   n = n_elements(id)

   ;if n le 1 then return, -1

   usno = replicate({id:0.D, sra:'',sdec:'',ra:0.D, dec:0.D, $
                     u:0.,g:0.,r:0.,i:0.,z:0.,                     Uj:0., Bj:0.,Vj:0.,Rc:0.,Ic:0., $
                     u_unc:0.,g_unc:0.,r_unc:0.,i_unc:0.,z_unc:0., Uj_unc:0.,Bj_unc:0.,Vj_unc:0.,Rc_unc:0.,Ic_unc:0., $
                     type:0},n)
   usno.id = id
   usno.sra = sra
   usno.sdec = sdec
   for ii = 0, n_elements(sra)-1 do begin
     usno[ii].ra = 15*ten(sra[ii])
     usno[ii].dec = ten(sdec[ii])
   endfor
   usno.Bj = B2
   usno.Rc = R2
   usno.Ic = I

   ; don't bother with any transforms for now, this is really just for R...

   return, usno

end
