pro lookupstandardlines, stdname, lines, linev, linesnt, linevnt

         ; get the list of lines and widths for a standard star.

         hydrogen = [6562.80, 4861.34, 4340.48, 4101.75, 3970.09, 3889.07, $
                     3835.40, 3797.92, 3770.65, 3750.17, 3734.39, 3721.96, $
                     3711.99, 3703.88, 3697.17, 3691.58, 3686.85, 3682.83]
         hv = 0.003 + (hydrogen gt 3900)*0.007
         calcium = [3968.5, 3933.7]
         cav = 0.003 + fltarr(n_elements(calcium))
         telluric = [6890., 7280., 7670., 8150., 9060., 9480.]
         tellv = [0.008, 0.018, 0.011, 0.004, 0.013, 0.022]
         helium = [4685., 5411.]  ; 5411 can potentially be at the limit of the red wavelength coverage, causing problems
         hev =   [0.005, 0.005] ; guess

         ; Default set of lines (everything)
         linesnt = [hydrogen, calcium, helium]
         linevnt = [hv, cav, hev]

         ; Or, if it's a standard we know and love, hard-code some custom lines instead
         if stdname eq 'G191-B2B' then begin
            linesnt = [hydrogen[0:5]]   ; No helium or calcium, higher-order hydrogen weak
            linevnt = [hv[0:5]]
         endif

         ; Always add telluric lines (which sadly can't be avoided)
         lines = [linesnt, telluric]
         linev = [linevnt, tellv]

end
