pro matchcat, ra1, dec1, ra2, dec2, match1, match2, map12, map21, mindist=mindist, xy=xy, nmatch=nmatch

  n1 = n_elements(ra1)
  n2 = n_elements(ra2)

  if keyword_set(xy) then cosdec = 1. else $
                          cosdec = cos(!pi*median([dec1])/180.)

  map12 = intarr(n1)-1  ; for a source in list 1, the list2 ID of its match
  map21 = intarr(n2)-1  ; for a source in list 2, the list1 ID of its match
  match1 = intarr(n1 < n2) ; list of IDs in list 1 that have matches
  match2 = intarr(n1 < n2) ; list of IDs in list 2 that have matches, same order as for match1

  n = 0
  for i = 0, n_elements(ra1)-1 do begin
     m = nearest(ra1[i]*cosdec, dec1[i], ra2*cosdec, dec2, mindist=mindist)
     if m ge 0 then begin
        map12[i] = m
        map21[m] = i
        if n ge n_elements(match1) then begin  ; very unusual situation of having more matches than things to match to
          match1 = [match1, 0]
          match2 = [match2, 0]
        endif
        match1[n] = i
        match2[n] = m
        n += 1
     endif
  endfor
 
  ; would be useful to add a treatment of conflicting matches here, but currently there is none

  if n ge 1 then begin
     match1 = match1[0:n-1]
     match2 = match2[0:n-1]
  endif
  if n eq 0 then begin
     match1 = -1
     match2 = -1
  endif

  nmatch = n
 
end

