function polyfitg, x, y, degree, guess=guessin, yfit=yfit, _EXTRA=ex, residual=residual, chi2=chi2

; polyfit with initial guess.
; fits to the residuals.

if n_elements(guessin) gt 0 then begin
  guess = guessin
  if (size(guess)) [0] gt 1 and (size(guess)) [2] gt 1 then guess = transpose(guess)
  while n_elements(guess) lt degree+1 do guess = [guess, 0.]
endif else begin
  guess = fltarr(degree+1)
endelse

model = poly(x, guess) ; model based on the initial guess
residual = y - model
chi2 = total(residual^2)

result = poly_fit(x, residual, degree, yfit=ryfit, _EXTRA=ex)
if (size(result)) [0] gt 1 and (size(result)) [2] gt 1 then result = transpose(result)

yfit = model + ryfit
newresidual = y - yfit
newchi2 = total(newresidual^2)

if chi2 lt newchi2 then begin
   ; print, '   Warning: polyfitg residuals increased at degree ', clip(degree), '; keeping old model.'
   yfit = model
   return, guess
endif

chi2 = newchi2
residual = newresidual
return, guess + result

end

