pro removelines, wav, flux, newflux, lines=lines, vel=vel, interpolate=interpolate, nan=nan, linezone=linezone

 ; remove lines in a flux star.

 ;good = intarr(n_elements(wav))+1   ; array indicating values to keep (1) versus remove or interpolate over (0)
 good = finite(flux) ;  pre-existing bad values are treated like lines now.

 for l = 0, n_elements(lines)-1 do begin
   cwav = lines[l]
   if n_elements(vel) gt 1 then v = vel[l] else v = vel
   linez = where(wav gt cwav*(1-v) and wav lt cwav*(1+v), ct)
   if ct gt 0 then good[linez] = 0
 endfor
 good[0:4] = 1
 good[n_elements(good)-11:n_elements(good)-1] = 1   ; never interpolate the edges

 linezone = abs(1 - good) ; a bool array for return to user
 wgood = where(good, ct, complement=notgood)
 if ct eq 0 then print, 'Entire spectrum is affected by lines?'

 if keyword_set(interpolate) eq 0 and keyword_set(nan) eq 0 then begin
    ; default behavior is just to trim out the line-affected parts of the spectrum
    wav = wav[wgood]
    flux = flux[wgood]
 endif else begin
    ; can also specify to mark with NaN, or interpolate over
    if keyword_set(nan) then begin
       flux[notgood] = !values.f_nan
    endif
    if keyword_set(interpolate) then begin
       ; median-filter the array before interpolation
       fluxmedfilt = median(flux,5)
       newflux = interpol2(fluxmedfilt[wgood], wav[wgood], wav)
    endif
 endelse

end

