pro updatefile, filename, newlines, sep=sep
  
  ; Updates a file by replacing a line with the same first word as the input line.
  ; The inserted line can be an array to add multiple lines at once

   ; read the file into an array
   if file_test(filename) eq 0 then begin
      lines = ['#', ''] ; create a blank line array if no file yet
   endif else begin
      openr, 9, filename
      lines = strarr(1)
      inline = ''
      while not eof(9) do begin
         readf, 9, inline
         lines = [lines, inline]
      endwhile 
      lines = lines[1:*]
      close, 9
   endelse

   ; ignore the first line
   ;if n_elements(lines) gt 1 then begin
   ;   lines = lines[1:n_elements(lines)-1]
   ;endif

   for j = 0, n_elements(newlines)-1 do begin
      newline = newlines[j]

      if n_elements(sep) gt 0 then split = strsplit(newlines[j], sep, /extract) $
                              else split = strsplit(newlines[j], /extract)
      key = clip(split[0])

      ; look for the line we want to replace
      lreplace = -1
      for l = 0, n_elements(lines)-1 do begin
         inline = lines[l]
         if n_elements(sep) gt 0 then indata = strsplit(inline, sep, /extract) $
                                else indata = strsplit(inline, /extract)
         lkey = clip(indata[0])
         if lkey eq key then begin  ; found it
            lreplace = l            ; replace old line with new info
            break
         endif
      endfor
      if lreplace eq -1 then begin  ; didn't find it
         lines = [lines, '']        ; add a new line at the bottom
         lreplace = l
      endif

      lines[lreplace] = newline     ; do the replacement
   endfor

   ; write the modified file back to disk
   openw, 9, filename
   for l = 0, n_elements(lines)-1 do begin
       printf, 9, lines[l]
   endfor
   close, 9


end

