pro downloadkeckfiles, inst=inst, accountnum=accountnum, scratchnum=scratchnum, outdir=outdir, skipfirewall=skipfirewall, autocheck=autocheck

   if n_elements(inst) eq 0 then inst = 'LRIS'
   if inst eq 'LRIS' and n_elements(autocheck) eq 0 then autocheck = 1

   common keckpath, firewallopen, account, scratch

   if n_elements(skipfirewall) gt 0 then firewallopen = 1

   if n_elements(accountnum) gt 0 then account = accountnum
   if n_elements(scratchnum) gt 0 then scratch = scratchnum

   if n_elements(account) eq 0 then print, 'Account number not specified.'
   if n_elements(scratch) eq 0 then print, 'Disk number not specified.'
   if n_elements(account) eq 0 or n_elements(scratch) eq 0 then return

   if n_elements(firewallopen) eq 0 then begin
      print, 'Opening firewall... enter user "sshuser" and the appropriate ssh password'
      spawn, 'telnet 128.171.99.33 259'
      firewallopen = 1
      print
   endif

   user = strlowcase(inst) + clip(account) 
   server = 'sshserver1.keck.hawaii.edu'
   remotepath = '/h/scratch'+clip(scratch)+'/'+strlowcase(inst)+clip(account)+'/'
  
   if strlowcase(inst) eq 'lris' then filestr = '???????_????.fits'
   if strlowcase(inst) eq 'deimos' then filestr = 'd????_????.fits'
   if strlowcase(inst) eq 'mosfire' then filestr = 'm??????_????.fits'
   if n_elements(filestr) eq 0 then filestr = '*.fits'
   if n_elements(outdir) eq 0 then outdir = './'

   print, 'Enter instrument account password:'
   cmd = 'rsync --ignore-existing -v -e ssh ' + user+'@'+server+':"'+remotepath+filestr+'" '+outdir
   print, cmd
   spawn, cmd

   if keyword_set(autocheck) then begin
       print
       print, 'Automatically checking for missing header data...'
       lriscorrectheaders
   endif

end

