pro lrisname, filestr, check=check
   
  ; modified by sapna mishra, but see lrisrename for my updated version

  if n_elements(filestr) eq 0 then begin
     print, 'Specify files to rename (or file wildcard string).'
     print, "   For KOA files, try: 'L?.*.fits'"
     return
  endif
  if n_elements(filestr) eq 1 then files = findfile(filestr) else files = filestr
  f_arr=lonarr(n_elements(files) )
  
  for f = 0, n_elements(files)-1 do begin
     if files[f] eq '' then begin
        print, 'No files matching ', filesstr
     endif
     h = headfits(files[f])
 
     filenum = sxpar(h,'FRAMENO', count=ct)
     if ct eq 0 then begin
        print, 'WARNING: File header is missing frame number! ', files[f]
        print, '  Not renaming.'
        continue
     endif
     filestr = string(filenum,'(I04)')
     
     idx=WHERE( f_arr EQ filestr , count)                    ;; To account for same filenum
     if count gt 0 then filestr = string(count,'(I01)')+string(filenum,'(I03)')
     print,filestr
    
     instrume = clip(sxpar(h,'INSTRUME'))
     inststr = ''
     if instrume eq 'LRIS' then inststr = 'r'
     if instrume eq 'LRISBLUE' then inststr = 'b'
     if inststr eq '' then begin
       print, 'Cannot recognize instrument.'
       continue
     endif
     utdate = sxpar(h,'DATE', /silent)

     tt=strpos(utdate,'/')                                  ;; To account for dates saperated by /
     if tt gt 0 then begin
        utdate=(strsplit(utdate,'/',/extract))
        datestr = strjoin(reverse(utdate))
     ENDIF  else begin
           
     utdate = (strsplit(utdate,'T',/extract)) [0]
     datestr = repstr(strmid(utdate,2),'-','')
      endelse
     
     

    ; outname = inststr + datestr + '_' + filestr +'_'+((strsplit(sxpar(h,'KOAID'),'.',/extract)) [2])+'.fits'
     outname = inststr + datestr + '_' + filestr +'.fits'
     print,outname
        
     if file_test(outname) then begin
        print, 'WARNING: File already exists!: ', outname, ' (from '
        print, '   Not overwriting.'
        continue
     endif
    
     print, files[f], ' -> ', outname
     
     if keyword_set(check) eq 0 then spawn, 'mv '+files[f]+' '+outname 
   f_arr[f]= filestr
  endfor


end

