pro lrisplotprofiles2

   common lrisauto, autoastrocommand, swarpcommand, datadir, imworkingdir, spworkingdir2d, spworkingdir1d, imfinaldir, spfinaldir, lrisversion, wildchar, overwrite, fileseq, filterstr, gratingstr, targetstr, defaulttraceyred, defaulttraceyblue, displayoff, debug
   common lrisconfig, lrisautopath, refdatapath, defaultspath

   if n_elements(spworkingdir1d) eq 0 then begin
      print, " Must run autolrisdefaults,mode='s' to use lrisplotprofiles at command line."
      return
   endif

   objfile = spworkingdir1d+'objectpos.txt'
   userobjfile = 'userobjectpos.txt'

   tr = loadobjectposfile(objfile, ct=ntr)
   usertr = loadobjectposfile(userobjfile, ct=nutr)
   for u = 0, nutr-1 do begin
      w = where(usertr[u].file eq tr.file, ctmatch) 
      if ctmatch gt 0 then tr[w[0]] = usertr[u]      ; should mark user-specified profiles on the plot
   endfor

   ofile = tr.file
   ocen = tr.yfix
   orad = tr.aprad

   ; Plot the profiles

   proffiles = file_search(spworkingdir1d+'ls'+'?'+'*.profile', count=nfiles) 
   fitsfiles = repstr(proffiles,'.profile','.fits')
   fileh = readlrisheaders(fitsfiles)

   keep = intarr(n_elements(fileh))
   for f = 0, n_elements(fileh)-1 do begin
      readstandard, fileh[f].target, pos=[fileh[f].radeg, fileh[f].decdeg], stdname=stdname, /check, result=result, path=refdatapath+'/'
      keep[f] = result eq 0; also have some min. exposure time?
   endfor
   wkeep = where(keep, nfiles)
   if nfiles eq 0 then return
   proffiles = proffiles[wkeep]
   fitsfiles = fitsfiles[wkeep]
   fileh = fileh[wkeep]
   ord = sort(fileh.mjd)
   proffiles = proffiles[ord] 
   fitsfiles = fitsfiles[ord]
   fileh = fileh[ord]



   profileplotfile = 'profiles.ps'


     ; plot all the spatial profiles
 
      psopen, profileplotfile, xsize=8.0, ysize=10, /inches
      device, /color
      !p.font=0
      device, /helvetica, font_index=17 
      colors = transpose([[0,0,0],$
                      [255,0,0],$ 
                      [100,100,0],$ 
                      [0,200,0],$ 
                      [160,160,0],$  
                      [10,255,10],$
                      [100,100,100],$
                      [255,255,255],$
                      [128,0,0],$
                      [0,0,128]])
      tvlct, colors
 
      !p.multi = [0,4,10]
      ybars = 0.04+0.95*findgen(11)/10
      py = 9+1
      dum = ''
      curt = [0., 0.]
      npy = -1

      for f = 0, nfiles-1 do begin
         profilefile = proffiles[f]
         fitsfilename = removepath(fitsfiles[f])
         fileroot = repstr(fitsfilename,'.fits','')
         readcol, profilefile, y, prof, format='f,f', comment='#', /silent
         cam = strmid(fileh[f].camera,0,1)
         ybin = fileh[f].ybin

         ow = where((ofile eq fitsfilename) or (ofile eq fileroot), ns)
         if ns eq 0 then begin
            ; print, 'No matching profile data for ', fitsfilename
            ;!p.position = [0,0,0.01,0.01]
            ;plot, [0],[0], /nodata, color=7
            ;plot, [0],[0], /nodata, color=7
            continue
         endif

         if (fileh[f].mjd ge curt[0] and fileh[f].mjd le curt[1]) or $
            (fileh[f].mjdstop ge curt[0] and fileh[f].mjdstop lt curt[1]) then begin
            ; matches the last one, so plot alongside it 
            curt = [0.,0.] 
            npy += 1
            if npy eq 2 then py -= 1
         endif else begin           
            if npy eq 0 then begin
                !p.position = [0,0,0.01,0.01]
                plot, [0],[0], /nodata, color=7
                plot, [0],[0], /nodata, color=7
            endif
            py -= 1
            if py lt 0 then py = 9
            curt = [fileh[f].mjd, fileh[f].mjdstop]
            npy = 0
         endelse

         for pi = 0, 1 do begin
           if cam eq 'b' and pi eq 0 then !p.position = [0.035, ybars[py], 0.145, ybars[py+1]]
           if cam eq 'b' and pi eq 1 then !p.position = [0.17, ybars[py], 0.50, ybars[py+1]]
           if cam eq 'r' and pi eq 0 then !p.position = [0.535, ybars[py], 0.645, ybars[py+1]]
           if cam eq 'r' and pi eq 1 then !p.position = [0.67, ybars[py], 0.99, ybars[py+1]]
           if pi eq 0 then begin
             xrange = ocen[ow[0]]+[-30,30]/fileh[f].ybin
             closey = where(y ge xrange[0] and y le xrange[1])
             yrange = [(1.1*min(prof[closey]) < (-1)) > min(prof[closey]), 1.05*max(prof[closey])]
           endif
           if pi eq 1 then begin
             xrange = [min(y)+20/ybin, max(y)-50/ybin]
             ;goody = where(y gt 5 and y lt max(y)-10)
             goody = where(y gt xrange[0] and y lt xrange[1])
             yrange = [1.1*min(prof[goody]) < (-1),  1.05*max(prof[goody])]
           endif
           if yrange[1]-yrange[0] gt 5 then ytf = '(I)' else ytf = ''
           plot, y, prof, /xsty, xrange=xrange, yrange=yrange, /ysty, ytickformat=ytf
           oplot, [0,max(y)], [0,0], color=6
           for si = 0, ns-1 do begin
             s = ow[si]
             oplot, ocen[[s,s]], [-1e5,1e5], color=1
             xyouts, ocen[s]+1, max(yrange)-(max(yrange)-min(yrange))*0.1, clipzero(ocen[s]), orient=-90, charsize=0.6, color=1
             oplot, ocen[[s,s]]-orad[[s,s]], [-1e5,1e5], color=3, linestyle=2
             oplot, ocen[[s,s]]+orad[[s,s]], [-1e5,1e5], color=3, linestyle=2
             oplot, ocen[[s,s]]-tr[s].bakmin[0], [-1e5,1e5], color=2, linestyle=1
             oplot, ocen[[s,s]]-tr[s].bakmax[0], [-1e5,1e5], color=2, linestyle=1
             oplot, ocen[[s,s]]+tr[s].bakmin[1], [-1e5,1e5], color=2, linestyle=1
             oplot, ocen[[s,s]]+tr[s].bakmax[1], [-1e5,1e5], color=2, linestyle=1
           endfor
         endfor
         if cam eq 'b' then color = 9 else color = 8
         xyouts, xrange[0]+0.35*(xrange[1]-xrange[0]), yrange[1]-(yrange[1]-yrange[0])*0.2, fileroot, charsize=0.77, color=color
         ; xyouts, 0.7, ybars[py+1]-0.15, '@ x='+clip(xref), /norm, charsize=0.59

      endfor 
      psclose
      retitleplot, profileplotfile, 'LRIS Profiles'


end
