pro lrisplotskyone, specfile, x0=x0, x1=x1, y0=y0, y1=y1, xs=xs, ys=ys, last=last, xrange=xrange
   ; plots the sky in a spectrum compared to the reference sky.

   ; need to look at dependencies directory, not home directory, for sky spectrum (should get a better sky spectrum, too...)

   common refsky, refskywavnm, refskyflux, refskyfluxsub

   s = readspec(specfile, h)  ; no timenorm - alredy fluxcalibrated...
   s.sky /= (1+2.*sxpar(h,'APRAD'))

   if n_elements(skyflux) eq 0 then begin
     readcol, '~/progs/idl/lris/refdata/skybg_50_10.dat', refskywavnm, refskyflux, /silent
     nw = n_elements(refskyflux)
     refskyfluxsub = refskyflux
     for i = 0, n_elements(refskyflux)-1 do begin
         refskyfluxsub[i] = refskyflux[i] - (min(refskyflux[(i-100)>0:(i+100)<(nw-2)]) > 0.)
     endfor
   endif

   target = sxpar(h,'TARGNAME')
   gra = sxpar(h,'GRNAME')
   cwav = sxpar(h,'CWAV') ; it's CWAVE in the 2D spec...
   upos = strpos(target,'_')
   if upos gt 3 then target = strmid(target,0,upos)
   
   !p.position = [(x0+12.)/xs, (y0+1.)/ys, (x1-2.)/xs, (y1-1.)/ys]
   if keyword_set(last) eq 0 then xtickformat='(A1)' else xtickformat='(I)'
   y = 2d20*s.sky/s.wav
   plot, [0], [0], xminor=5, yminor=1, xticklen=0.1, /noerase, xrange=xrange, /xsty, xtickformat=xtickformat, color=rgb(200,200,200), yrange=[0, max(y)], yticklen=0.01

   oplot, refskywavnm*10., 500.*refskyfluxsub/refskywavnm, color=rgb(0,0,255)
   oplot, s.wav, y

   xyouts, x0+35, y1-11, removepath(repstr(specfile,'.spec',''))+ ' ('+target+')', charsize=1, /device, color=rgb(220,220,220)
   xyouts, x0+900,y1-11, clip(gra)+' w='+clip(fpr(cwav,5.1)), charsize=1, /device, color=rgb(210,210,210)


end


pro lrisplotsky, camera=camera
 
   spworkingdir = './' ;'spredux/'
   wildchar='*'

   camchar = strmid(camera,0,1)
   chipchar = 'r'
   specfiles = choosefiles(camchar+wildchar+chipchar+'.spec',spworkingdir+'ceszfp',spworkingdir+'cesfp')
    
   nfiles = n_elements(specfiles)

   yboxsize = 50
   yhead = 5
   yfoot = 20
   outx0 = 5
   yborder = 1
   xwin = 1024+outx0
   maxperpage = (600-yhead-yfoot)/(yboxsize+2*yborder)
   
   p = 0
   for i = 0, nfiles-1 do begin
      pi = (i mod maxperpage)
      if pi eq 0 then begin
         ywin = (nfiles-(maxperpage*p) < maxperpage)*(yboxsize+2*yborder)+yhead+yfoot
         window, 2, xsize=xwin, ysize=ywin
         p += 1
      endif

      if camchar eq 'b' then xrange=[3000,6000]
      if camchar eq 'r' then xrange=[5000,10500]

      outy0 = ywin - yhead - (pi+1)*(yboxsize+2*yborder) + yborder
      if i eq maxperpage-1 or i eq nfiles-1 then last=1 else last=0
      lrisplotskyone, specfiles[i], x0=outx0, y0=outy0, x1=xwin, y1=outy0+yboxsize, xs=xwin, ys=ywin, last=last, xrange=xrange

      if last then write_png, spworkingdir+'lris'+strmid(camchar,0,1)+'skyspec'+clip(p)+'.png', tvrd(/true)
   endfor

   skyspecpngblue = file_search(spworkingdir+'lrisbskyspec*.png')
   skyspecpngred = file_search(spworkingdir+'lrisrskyspec*.png')
   openw, 7, spworkingdir+'lrisskyspec.html'
     printf, 7, '<html>'
     printf, 7, '<head>'
     printf, 7, '<title>LPIPE sky spectrum check page</title>'
     printf, 7, '</head>'
     printf, 7, '<body>'
     printf, 7, '<table>'
     printf, 7, '<tr><td valign="top">'
     for g = 0, n_elements(skyspecpngblue)-1 do  printf, 7, '<img src="'+removepath(skyspecpngblue[g])+'"/>'
     printf, 7, '</td><td valign="top">'
     for g = 0, n_elements(skyspecpngred)-1 do   printf, 7, '<img src="'+removepath(skyspecpngred[g])+'"/>'
     printf, 7, '</td>'
     printf, 7, '</body>'
     printf, 7, '</html>'
   close, 7


end


