pro purge, target=target, prefix=prefix, mode=mode

  ; prefix = '' or prefix = '*' for ALL files
  ; prefix blank or prefix = 'x' for combined files only


  if n_elements(prefix) eq 0 then prefix = 'x'

  ; delete all files matching the stated conditions (for pipeline reruns).

  ; being lazy about directory names.  also imaging/spectroscopy since it could be local directory.

  if n_elements(mode) eq 0 then mode='i,s'
  if n_elements(camera) eq 0 then camera = ''

  files = ['']
  if strpos(mode,'i') ge 0 then begin
     files = [files, file_search('imredux/*coadd*.fits'), $
                     file_search('imredux/*'+prefix+'??????_*.fits'), $ 
                     file_search('imredux/*'+prefix+'??????_*.*ca?')] 
  endif 
  if strpos(mode,'s') ge 0 then begin
     files = [files, file_search('spredux/*'+prefix+'??????_*.fits'), $
                     file_search('spredux/*'+prefix+'??????_*.spec'), $
                     file_search('spredux/vc*.spec'), $
                     file_search('./lris*.spec')]
  endif

  ; might be more efficient to use the literal prefix and do the rm on the *+prefix
  ; not sure if spec is working, try later

  purgelist = ''
  purgetarglist = ''
 
  shorttarget = (strsplit(target,'_',/extract)) [0]

  for f = 0, n_elements(files)-1 do begin
     if files[f] eq '' then continue
     if strpos(files[f],'.ca') ge 0 or strpos(files[f],'.tca') ge 0 then c = readcat(files[f], h)
     if strpos(files[f],'.fit') ge 0 then h = headfits(files[f])
     if strpos(files[f],'.spec') ge 0 then s = readspec(files[f], h)

     if n_elements(h) lt 2 then begin
        purgelist = [purgelist, files[f]]
        purgetarglist = [purgetarglist, '?']
        continue
     endif

     ftarget = clip(sxpar(h,'TARGNAME'))

     if target eq ftarget or shorttarget eq (strsplit(ftarget,'_',/extract)) [0] then begin
        purgelist = [purgelist, files[f]]
        purgetarglist = [purgetarglist, ftarget]
     endif

  endfor
 
  valid = where(purgelist ne '', ct)
  if ct eq 0 then begin
    print, 'No matches.'
    return
  endif
  purgelist = purgelist[valid]
  purgetarglist = purgetarglist[valid]

  cmd = 'rm -f '
  print, 'Purging the following files:'
  p = ''
  for t = 0, ct-1 do begin
    filename = removepath(purgelist[t])
    dotpos = strpos(filename,'.')
    fileroot = strmid(filename,0,dotpos)
    fileext  = strmid(filename,dotpos+1)
    print, rclip(fileroot,22)+'.'+clip(fileext,8), ' ', purgetarglist[t]
    cmd += purgelist[t]+' '
  endfor
  read, 'OK to delete? (y/n): ', p      
  p = strlowcase(p)
  print, cmd
  if p eq 'y' or p eq 'yes' then spawn, cmd

end

