function readcatheader, files, count=count, loud=loud

   count = 0
   if n_elements(files) eq 0 then return, -1
   if clip(files[0]) eq '' then return, -1
   info = replicate({file:'', exp:0., filt:'', dich:'', filtdich:'', target:'', airmass:0., zpt:0., zptunc:0., apcorr:0., nap:0, nstar:0, type:'', seeing:0., rzpt:0.}, n_elements(files))
   for f = 0, n_elements(files)-1 do begin
      cat = readcat(files[f], h)
      info[f].file = files[f]
      info[f].exp = sxpar(h,'EXPTIME')
      info[f].filt = clip(sxpar(h,'FILTER'))
      info[f].dich = clip(sxpar(h,'DICHNAME'))
      info[f].filtdich = info[f].filt+'/'+info[f].dich
      info[f].airmass = sxpar(h,'AIRMASS')
      info[f].zpt = sxpar(h,'ZEROPT')
      info[f].zptunc = sxpar(h,'ZPTUNC')
      info[f].apcorr = sxpar(h,'APCORR')
      info[f].type = clip(sxpar(h,'PHOTCAL'))
      info[f].target = clip(sxpar(h,'TARGNAME'))
      info[f].nap = clip(sxpar(h,'NSTARSAP'))
      info[f].nstar = clip(sxpar(h,'NSTARS'))
      info[f].seeing = clip(sxpar(h,'SEEING'))
      info[f].rzpt = clip(sxpar(h,'RZPT'))

      if keyword_set(loud) then print, info[f].file, fpr(info[f].exp+0.001,4.2) , ' ', clip(info[f].filtdich,10), ' ', fpr(info[f].airmass,2.3), ' ', fpr(info[f].zpt,3.3), ' ', fpr(info[f].zptunc,2.3), ' ', fpr(info[f].apcorr,2.3)
   endfor

   count = n_elements(cat)
   return, info
end

