function readlrisr1, filename, header=header, nobias=nobias, verbose=verbose

   im = readfits(filename, header, /silent)*1.0
   ;im = im - sxpar(header,'BZERO')
   sxaddpar, header, 'BZERO', 0

   prepix = sxpar(header,'PREPIX')   
   postpix = sxpar(header,'POSTPIX')   

   ; writefits, 'initim.fits', im, header

   s = size(im)
   nx = s[1]
   ny = s[2]


   window = fix(strsplit(sxpar(header,'WINDOW'),',',/extract))
   windowx = window[[0,2]]
   ; window is in binned coordinates, so does not need to be changed

   binning = fix(clip(strsplit(sxpar(header,'BINNING'),',',/extract)))
   xbin = binning[0]

   ampx = prepix*2 + 1024/xbin-window[0]

   bias1prex  = [1, prepix-1]
   bias2prex  = [prepix, prepix*2-2]
   data1x     = [prepix*2, ampx-1 < (nx - postpix*2-1)]
   data2x     = [ampx > (prepix*2), nx-postpix*2-1]
   datax      = [data1x[0] < data2x[0], data1x[1] > data2x[1]]
   bias1postx = [nx-postpix*2, nx-postpix-1]
   bias2postx = [nx-postpix, nx-1]

   sxaddpar, header, 'AMP1', clip(data1x[0]-datax[0])+','+clip(data1x[1]-datax[0])
   sxaddpar, header, 'AMP2', clip(data2x[0]-datax[0])+','+clip(data2x[1]-datax[0])
 
   if keyword_set(nobias) eq 0 then begin
     ;print, bias1prex,  median(im[bias1prex[0]:bias1prex[1],*])
     ;print, bias2prex,  median(im[bias2prex[0]:bias2prex[1],*])
     ;print, bias1postx, median(im[bias1postx[0]:bias1postx[1],*])
     ;print, bias2postx, median(im[bias2postx[0]:bias2postx[1],*])
     bias1 =fix((median(im[bias1prex[0]:bias1prex[1],*])+median(im[bias1postx[0]:bias1postx[1],*]))/2.)
     bias2 =fix((median(im[bias2prex[0]:bias2prex[1],*])+median(im[bias2postx[0]:bias2postx[1],*]))/2.)

     ;print, bias1, bias2

     im[bias1prex[0]:bias1prex[1],*] -= bias1
     im[bias1postx[0]:bias1postx[1],*] -= bias1  ; not necessary except as a check
     im[bias2prex[0]:bias2prex[1],*] -= bias2
     im[bias2postx[0]:bias2postx[1],*] -= bias2
     extrabias = 0 ; 9 ; the prepix/postpix don't seem to be enough...

     if data1x[0] gt 0 and data1x[1] gt data1x[0] then im[data1x[0]:data1x[1],*] -= (bias1 + extrabias)
     if data2x[0] gt 0 and data2x[1] gt data2x[0] then im[data2x[0]:data2x[1],*] -= (bias2 + extrabias)
   endif

   ; writefits, 'subim.fits', im, header

   sciim = im[datax[0]:datax[1],*]

   return, sciim
end

